
#if _MSC_VER >= 1000
#pragma once
/* This pragma disables STL symbol-length warnings in MSVC++ 5.0 */
#pragma warning(disable:4786)
#pragma warning(disable:4503)
#endif // _MSC_VER >= 1000



#ifdef WIN32
#include <winsock2.h>
#include <windows.h>

#else 
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <regex.h>
#include <netinet/in.h>
#include <netdb.h>
#endif

#include <string.h>
#include <math.h>
#include <stdio.h>

#ifdef TELNET_EXPORTS
#define TELNET_API __declspec(dllexport)
#else
#define TELNET_API __declspec(dllimport)
#endif

#define	TELNET_IAC		(u_char)255
#define	TELNET_DONT		(u_char)254
#define	TELNET_DO		(u_char)253
#define	TELNET_WONT		(u_char)252
#define	TELNET_WILL		(u_char)251
#define TELOPT_ECHO		(u_char)1

#define TELNET_PORT		(short)23

#define MIN_MSG_SIZE		1024
#define DEFAULT_MSG_SIZE	65536
#define DEFAULT_HOST		"localhost"
#define DEFAULT_PROMPT		"[$%#>] "
#define DEFAULT_LOGINTIME	5.000
#define	DEFAULT_WAITTIME	1.500

#define MSGCHK_SIZE			40

#define COMMAND_LENGTH		30

// This class is exported from the telnet.dll

#ifdef WIN32
class TELNET_API CTelnet {
#else
class CTelnet {
#endif

private:

	char	m_host[100];
	int		m_port;
	char	m_prompt[100];
	timeval	m_loginWaitTimeOut;
	timeval	m_waitTimeOut;
	int		m_messageSize;

	char	m_user[100];
	char	m_password[100];

#ifdef WIN32
	SOCKET	m_sock;
#else
	int	m_sock;
#endif
	bool	m_isSock;
	bool	m_isConnect;
	bool	m_isWaitTimeOut;

	char*	p_message;

	unsigned char getTelnetChar(void);

public:

	CTelnet(
		const char* host =			DEFAULT_HOST,
		int messageSize =			DEFAULT_MSG_SIZE,
		const char* prompt =		DEFAULT_PROMPT,
		int port =					TELNET_PORT, 
		double loginTimeOut =		DEFAULT_LOGINTIME, 
		double waitTimeOut =		DEFAULT_WAITTIME
	);

	~CTelnet();

	bool isConnect();

	bool login(const char* user, const char* password ="");

	bool cmd(const char* str);

	bool cmd(const char* str, timeval waitTimeOut);

	bool cmd(const char* str, const char* waitstr);

	bool cmd(const char* str, const char* waitstr, timeval waitTimeOut);

	bool waitfor(const char *str);

	bool waitfor(const char* str, timeval waitTimeOut);

	char* getmsg();
	


};
